<p align="center">
 <img src="https://freetubeapp.github.io/images/logoColor.png" width=500 align="center">
</p>

# The FreeTube Vue.js Rewrite

FreeTube is an open source desktop YouTube player built with privacy in mind.  This repository specifically is about a rewrite of FreeTube that is actively being worked on.  FreeTube will be rewritten from the ground up to take advantage of better coding practices and to make proper use of Vue.js compared to the previous code base.  You can read more about why a rewrite is in development over at the related [blog post](#).

This version of FreeTube is not finished.  It is in active development and a lot of features (Even ones that are already implemented in FreeTube).  Almost all features are being remade.

## Contributing

Since the code base is smaller and ever expanding.  Now is a great time to get involved with contributing to FreeTube.  There are a lot of things that need to be done right now and the more help we can get the better.

Check out the [getting started](#) page over on the wiki on how to get your environment setup.  Since this is a rewrite, that means that there are things that we'd like to avoid to prevent the same issues from the old code base.  Because of this, there are some coding standards that we'd like to keep while working on this rewrite.

Enough of the rewrite has been done to hopefully provide code examples of what we'd like to see moving forward.  Just because standards are already made, it doesn't mean that I'm not open to suggestions for changing things.  I would love to hear your thoughts on if you believe that something about our methods can be improved on.

## What Needs to be Done?

Like I mentioned above, there are a lot of things that need to be done.  I have created some issues over at the [issues](#) page to give a quick rundown on what needs to be done as well as what the requirements are in order for those issues to be considered complete.  I will make more issues with more requirements as progress is made.

At this time, here is the list of things to do/need to do:

- [x] Setup App Environment
- [x] Basic App Structure and Layout
- [x] Video Layout (Along with Channel and Playlist Layout)
- [x] Search / Search View (Along with Filters)
- [ ] Search Suggestions
- [x] Channel View
- [x] Channel Search
- [x] Trending Page
- [x] Most Popular Page
- [x] Playlist View
- [x] Video Watch Page (Recommendations, Comments)
- [ ] Video player logic (Switching formats / quality, live video, fallback logic)
- [ ] Playlist logic (Autoplay next video, shuffle list)
- [ ] Database Setup and Logic (Updating and creating data)
- [ ] Settings Page
- [ ] Subscriptions Page and Logic
- [ ] Playlists Page (Will allow for creating user playlists.  Will replace the "Favorites" Page)
- [ ] History Page
- [ ] Profile Page and Logic
- [ ] Misc. Adjustments and Settings
- [ ] Packagaing and Testing

This list is somewhat in order of when I plan on working on each thing.  Obviously things can change and anyone is welcome to work on whatever they like whenever.
